/* --COPYRIGHT--,BSD
 * Copyright (C) 2014 Texas Instruments Incorporated - http://www.ti.com/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

/*******************************************************************************
 *
 *  key.c - keys dealing functions
 *
 ******************************************************************************/

#include "key.h"
#include "global.h"
#include "init.h"

void KeyDeal() // Put this function into a 2~6ms time cycle loop
{
	// key S1 input dealing
	if ( ((P1IN & BIT2)==0)&&(inputS1Down==0) ) // button pushed
	{
		inputS1Down = 1;
		switch(stateFan)
		{
		case STATE_FAN_STOP: 		// fan stop
			stateFan = STATE_FAN_POWER_RAMP;
			break;
		case STATE_FAN_POWER_RAMP: 	// fan ramp up
			stateFan = STATE_FAN_STOP;
			break;
		case STATE_FAN_RUN:  		// fan running
			stateFan = STATE_FAN_STOP;
			break;
		default:
			break;
		}
	}
	else if (P1IN & BIT2)
	{
		inputS1Down = 0;
	}

	// key S2 input dealing
	if ( ((P1IN & BIT3)==0)&&(inputS2Down==0) ) // button pushed
	{
		inputS2Down = 1;
		switch(throttleState)
		{
		case 4:
			throttleState = THROTTLE_STATE_OPEN;
			break;
		case 2:
		case 3:
			throttleState = THROTTLE_STATE_STOP;
			break;
		case 1:
			throttleState = THROTTLE_STATE_ORG;
			break;
		default:
			break;
		}
	}
	else if (P1IN & BIT3)
	{
		inputS2Down = 0;
	}
}
